#if 0 /* -*- mode: c; c-file-style: "stroustrup"; tab-width: 8; -*-
 set -eu; TRG=`basename $0 .c`; rm -f "$TRG"
 WARN="-Wall -Wno-long-long -Wstrict-prototypes -pedantic"
 WARN="$WARN -Wcast-align -Wpointer-arith " # -Wfloat-equal #-Werror
 WARN="$WARN -W -Wwrite-strings -Wcast-qual -Wshadow" # -Wconversion
 case ${1:-} in '') set x -O2 ### set x -ggdb;
	shift ;; esac;
 LIBOSSO=`pkg-config --cflags --libs libosso`
 set -x; ${CC:-gcc} --std=gnu99 $WARN "$@" -o "$TRG" "$0" $LIBOSSO
 exit $?
 */
#endif

#include <unistd.h>
#include <stdlib.h>
#include <sys/wait.h>
#include <libosso.h>

#define null ((void*)0)
#define true (1)

static void exec_child(void)
{
    if (fork())
	return;

    uid_t uid = geteuid();
    gid_t gid = getegid();

    setreuid(uid, uid);
    setregid(gid, gid);

    execl("/bin/su", "su", "-", "developer", "-c",
	  "cd /usr/lib/wwcalc; exec ./wwcalc-withhome.sh ./wwcalc",
	  (void *)0);
    exit(1);
}

int main(int argc, char * argv[])
{
    (void)argc; (void)argv;

    osso_context_t *
	osso_context = osso_initialize("com.nokia.wwcalc","1.0",1,null);
    exec_child();
    /* too lazy to drop privileges. maybe the following code is safe */
    wait(null);
    osso_deinitialize(osso_context);
    return 0;
}
